# GB Header Extractor

This is a tool that extracts header information from GameBoy and GameBoy Color ROM files and writes it as comma separated values into a file (A CSV file). It is designed for simplicity and only works on Windows operating systems.

The extracted information contains the following:
* The filename of the ROM
* The game/software title
* The game code (if it exists)
* The publisher/maker
* GameBoy Color support flag
* Super GameBoy support flag
* The PAK/Cartridge type
* The size of the ROM in KiB
* The size of additional RAM in KiB
* The destination code
* The software version

This tool has been written by `Daniel Drywa`. More information about this tool can be found at https://www.drywa.me/gb-header-extractor/.
If you encounter any issues or would like to provide some feedback, contact me at `contact@drywa.me`.

## Usage

To use this tool copy the executable `GBHeaderExtractor.exe` into the folder that contains your GameBoy and/or GameBoy Color ROM files. Double click the executable to run the program. A new file named `output.csv` will appear in the same folder as the executable. This file contains the header information of all the ROM files in the same location.
Keep in mind that this tool will not extract information from files in any of the sub-folders. Only files in the same location as the executable are read.

## Advanced usage options

If the simple use case is not enough, this tool can also be used from the terminal with additional command line arguments.
All arguments are optional and if none of them are supplied the tool will execute in the same manner as described in the usage section above.

`-input [PATH]`: Replace `[PATH]` with a valid path to the ROM files you wish to extract information of. If this argument is not supplied, the current working directory of the `GBHeaderExtractor.exe` is used as a default.

`-output [PATH]`: Replace `[PATH]` with a valid path or filename to use as the output file to write all header information to. If the supplied path is not a filename but a directory, `output.csv` will be created. If this argument is not supplied, `output.csv` will be put in the current working directory of the `GBHeaderExtractor.exe`.

`-stdout`: In addition to writing the header information into the specified output file it will also be printed onto the standard output stream. This can be useful if the information has to be piped into a different command line tool for additional formatting or other processing.

`-nofile`: If supplied, the tool will no longer write any information into the output file. Instead `-stdout` is enabled by default.

`-recursive`: If supplied, the tool will also process all files in any of the subfolders of the input path.

`-headless`: Omits writing the first line of the output that is used as the table header.

`-append`: Instead of overwriting an existing output file it will append to it.

`-gui`: This feature is not available yet.

## Changelist

Version 1.0.0.0 (2023-12-03): 
* This is the initial version of the `GBHeaderExtractor` tool.
